/*
DAC8253.C
Seriovy 2-kanalovy PWM DAC s 8253 na LPT
V1.2
(C) Ivan Dolezal
29. 8. 1997
*/

/* Prelozeno prekladacem Borland C++ 3.1, model SMALL */

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>

/* Prirazeni vyvodu 8253 ke CONTROL registru LPT
	8253	LPT
	----------
	A0		CR.0
	A1		CR.1
	/CS	L
	/RD	H
	/WR	CR.2	*/

#define  BLO(x)  *((unsigned char *)&(x))
#define  BHI(x)  *(((unsigned char *)&(x))+1)

#define CP		3
#define TIM0	0
#define TIM1	1
#define TIM2	2
#define CP0STAT	0x07 /* CS0=1 (neni invertovany), CS1=1, A0=0, A1=0 */

int port,lptbase;

/***************************/
void set8253( int reg, int value )
{
int stat;
outportb(lptbase+0,value);				/* nastav hodnotu na DATA port */
stat = CP0STAT & 0xFC | ~reg & 0x03;/* priprav adresni bity */
outportb(lptbase+2, stat);				/* nastav adresu registru */
outportb(lptbase+2, stat & 0xFB);   /* nastav WR=0 ... bit 2 */
outportb(lptbase+2, stat);   			/* nastav WR=1 ... bit 2 */
}

/***************************/
int main( int argc, char *argv[] )
{
unsigned int aux, ni, in1, in2, in3, period, period0, chan1, chan2;
char ins[81];
cputs("\n\n\r-- DAC8253 - V1.2 - PWM D/A prevodnik na LPT portu - (C) I. Dolezal 1997 --\n\r");
if (argc > 1)
	port = atoi(argv[1]);
else
	{  cputs("\n\rChybi parametr - cislo portu LPT !\n\r\a");  exit(1);  }
if (port==1)  lptbase = 0x378;
else if (port==2)  lptbase = 0x278;
else 	{  cputs("\n\rChybne cislo portu LPT - muze byt jen 1 nebo 2 !\n\r\a");  exit(1);  }
period0 = period = 0;
chan1 = chan2 = 1;
set8253(CP,0x34);				/* TIM0 v modu c.2 (asym. delic), zapis obou bajtu */
set8253(CP,0x72);				/* TIM1 v modu c.1 (MKO), zapis obou bajtu */
set8253(CP,0xB2);				/* TIM2 v modu c.1 (MKO), zapis obou bajtu */
set8253(TIM0,BLO(period));	/* nastaveni periody PWM do TIM0 */
set8253(TIM0,BHI(period));
set8253(TIM1,BLO(chan1));	/* nastaveni hodnoty PWM do TIM1 */
set8253(TIM1,BHI(chan1));
set8253(TIM2,BLO(chan2));	/* nastaveni hodnoty PWM do TIM2 */
set8253(TIM2,BHI(chan2));
while (1)
	{
	cputs("\n\rZadej -> Chan1 [Chan2 [Period]] : ");
	gets(ins);
	if (*ins == '\0')  return(0);	/* ukonceni programu na samotny ENTER */
	ni = sscanf(ins,"%u %u %u", &in1, &in2, &in3);
	switch (ni)
		{
		case 3 : period = in3;
		case 2 : chan2 = in2;
					chan2++;
					if (period != period0)
						{
						period0 = period;
						set8253(TIM0,BLO(period));	/* nastaveni periody PWM do TIM0 */
						set8253(TIM0,BHI(period));
						}
					set8253(TIM2,BLO(chan2));	/* nastaveni hodnoty PWM do TIM2 */
					set8253(TIM2,BHI(chan2));
		case 1 :	chan1 = in1;
					chan1++;
					set8253(TIM1,BLO(chan1));	/* nastaveni hodnoty PWM do TIM1 */
					set8253(TIM1,BHI(chan1));
					break;
		}
	}
}
